package com.data.ranges.clinet.config.runner;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.system.domain.DataAccess;
import com.muyu.system.remote.RemoteSystemManageService;
import lombok.extern.log4j.Log4j2;
import muyu.data.range.common.domain.Unit;
import muyu.data.range.common.domain.dataSoutce.DataSourceConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.sql.Connection;
import java.util.HashMap;
import java.util.List;

/**
 * 初始化加载
 */
@Log4j2
@Component
@Configuration
public class DataRangeConfigRunner implements ApplicationRunner {
    @Autowired
    private RemoteSystemManageService remoteSystemManageService;// 远程调用
    @Autowired
    private DataSourceConfig dataSourceConfig;
    @Override
    public void run(ApplicationArguments args) throws Exception {
        //远程调用
        Result<TableDataInfo<DataAccess>> listed = remoteSystemManageService.list(null);
        //判断非空
        if (listed.getData().getRows() == null || listed.getData().getRows().isEmpty()){
            log.error("数据为空");
            return;
        }
        //获取数据源集合
        List<DataAccess> listResultData = listed.getData().getRows();
        //存入map
        //创建map
        HashMap<Long, DataAccess> frimaryVoHashMap = new HashMap<>();
        //遍历循环存入map
        listResultData.forEach(res -> {
            frimaryVoHashMap.put(res.getId(),res);
        });
        //遍历添加到hashMap
        for (DataAccess listResultDatum : listResultData) {
            if (listResultDatum.getType() == "MySql"){
                //记录线程池
                dataSourceConfig.index(listResultDatum);
            }
        }
        //连接上线程池
        DataAccess dataAccess = listResultData.get(0);
        dataSourceConfig.verify(dataAccess.getId());
        //获取一个线程池
        Connection connection = dataSourceConfig.getConnection(dataAccess.getId());
        //归还线程池
        dataSourceConfig.returnConnection(connection);
        //将对象传入Spring
//        SpringHashMap(hashMap);
    }

    @Bean
    public HashMap<Long,Unit> SpringHashMap(HashMap<Long,Unit> hashMap) {
        return hashMap;
    }



}
