package com.muyu.edition.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.edition.domain.resp.AnduserIndexResp;
import com.muyu.edition.domain.resp.AnduserQueryResp;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("engine_config")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "Anduser", description = "测试项目")
public class Anduser extends BaseEntity {
    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    @ApiModelProperty(name = "主键", value = "主键")
    private Long id;
    /**
     * 名称
     */
    @TableId(value = "name")
    @ApiModelProperty(name = "名称", value = "名称")
    private String name;
    /**
     * 性别
     */
    @TableId(value = "sex")
    @ApiModelProperty(name = "性别", value = "性别")
    private String sex;
    /**
     * 年龄
     */
    @TableId(value = "age")
    @ApiModelProperty(name = "年龄", value = "年龄")
    private Integer age;

    /**
     * 查询
     */
    public static Anduser query(AnduserQueryResp anduserQueryResp) {
        return Anduser.builder()
                .name(anduserQueryResp.getName())
                .sex(anduserQueryResp.getSex())
                .age(anduserQueryResp.getAge())
                .build();
    }

    /**
     * 添加
     */
    public static Anduser index(AnduserIndexResp anduserIndexResp) {
        return Anduser.builder()
                .name(anduserIndexResp.getName())
                .sex(anduserIndexResp.getSex())
                .age(anduserIndexResp.getAge())
                .build();
    }

    /**
     * 修改
     */
}
