package com.muyu.edition.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 引擎对象 config
 *
 * @author muyu
 * @date 2024-05-04
 */
public class Config extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    private Long id;

    /**
     * 版本编码
     */
    @Excel(name = "版本编码")
    private String versionCode;

    /**
     * 规则内容
     */
    @Excel(name = "规则内容")
    private String ruleContent;

    /**
     * 注释
     */
    @Excel(name = "注释")
    private String remark;

    /**
     * 维护编号
     */
    @Excel(name = "维护编号")
    private Long ruleId;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getVersionCode() {
        return versionCode;
    }

    public void setVersionCode(String versionCode) {
        this.versionCode = versionCode;
    }

    public String getRuleContent() {
        return ruleContent;
    }

    public void setRuleContent(String ruleContent) {
        this.ruleContent = ruleContent;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Long getRuleId() {
        return ruleId;
    }

    public void setRuleId(Long ruleId) {
        this.ruleId = ruleId;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("versionCode", getVersionCode())
                .append("ruleContent", getRuleContent())
                .append("remark", getRemark())
                .append("ruleId", getRuleId())
                .toString();
    }
}
