package com.muyu.edition.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 规则引擎版本对象 edition
 *
 * @author muyu
 * @date 2024-05-06
 */
public class Edition extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    private Long id;

    /**
     * 规则序号
     */
    @Excel(name = "规则序号")
    private Long ruleId;

    /**
     * 版本类
     */
    @Excel(name = "版本类")
    private String versionClass;

    /**
     * 版本名称
     */
    @Excel(name = "版本名称")
    private String name;

    /**
     * 版本编码
     */
    @Excel(name = "版本编码")
    private String versionCode;

    /**
     * 版本状态
     */
    @Excel(name = "是否发布")
    private Integer editionStatus;

    /**
     * 引擎状态
     */
    @Excel(name = "是否激活")
    private String ruleStatus;

    @Excel(name = "是否测试")
    private Integer ruleIsTest;

    /**
     * 内容
     */
    @Excel(name = "内容描述")
    private String editionContent;

    @Excel(name = "规则内容")
    private String ruleContent;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getRuleId() {
        return ruleId;
    }

    public void setRuleId(Long ruleId) {
        this.ruleId = ruleId;
    }

    public String getVersionClass() {
        return versionClass;
    }

    public void setVersionClass(String versionClass) {
        this.versionClass = versionClass;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getVersionCode() {
        return versionCode;
    }

    public void setVersionCode(String versionCode) {
        this.versionCode = versionCode;
    }

    public Integer getEditionStatus() {
        return editionStatus;
    }

    public void setEditionStatus(Integer editionStatus) {
        this.editionStatus = editionStatus;
    }

    public String getRuleStatus() {
        return ruleStatus;
    }

    public void setRuleStatus(String ruleStatus) {
        this.ruleStatus = ruleStatus;
    }

    public Integer getRuleIsTest() {
        return ruleIsTest;
    }

    public void setRuleIsTest(Integer ruleIsTest) {
        this.ruleIsTest = ruleIsTest;
    }

    public String getEditionContent() {
        return editionContent;
    }

    public void setEditionContent(String editionContent) {
        this.editionContent = editionContent;
    }

    public String getRuleContent() {
        return ruleContent;
    }

    public void setRuleContent(String ruleContent) {
        this.ruleContent = ruleContent;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("ruleId", getRuleId())
                .append("versionClass", getVersionClass())
                .append("name", getName())
                .append("versionCode", getVersionCode())
                .append("editionStatus", getEditionStatus())
                .append("ruleStatus", getRuleStatus())
                .append("ruleIsTest", getRuleIsTest())
                .append("ruleContent", getRuleContent())
                .append("editionContent", getEditionContent())
                .toString();
    }
}
