package com.muyu.goods.edition.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.edition.domain.RuleEngine;
import com.muyu.goods.edition.remote.factory.DataMangFacrory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.GetMapping;

import java.util.List;

/**
 * 远程调用
 */
@FeignClient(
        contextId = "RemoteSys",
        value = ServiceNameConstants.EDITION_MUYU,
        fallbackFactory = DataMangFacrory.class,
        path = "/engine"
)
public interface RemoteDataManagerService {
    @GetMapping("/list")
    public Result<TableDataInfo<RuleEngine>> list(RuleEngine ruleEngine);

}
