package com.muyu.goods.edition.remote.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.edition.domain.RuleEngine;
import com.muyu.goods.edition.remote.RemoteDataManagerService;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.w3c.dom.stylesheets.LinkStyle;

import java.util.List;


/**
 * 熔断
 */
public class DataMangFacrory implements FallbackFactory<RemoteDataManagerService> {
    @Override
    public RemoteDataManagerService create(Throwable cause) {
        return new RemoteDataManagerService() {
            @Override
            public Result<TableDataInfo<RuleEngine>> list(RuleEngine ruleEngine) {
                return Result.error(cause.getMessage());
            }
        };
    }
}
