package com.muyu.edition.controller;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.edition.domain.Cope;
import com.muyu.edition.service.CopeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/cope")
public class CopeController extends BaseController {
    @Autowired
    private CopeService service;

    @PostMapping("/list")
    public Result<List<Cope>> list() {
        return success(service.list());
    }

    @PostMapping("/list2")
    public Result<List<Cope>> list2() {
        return success(service.list2());
    }

    @PostMapping("selType/{name}")
    public Result<List<Cope>> selType(@PathVariable String name) {
        return success(service.selType(name));
    }

    @PostMapping("selObject")
    public Result<List<Cope>> selObject(@RequestBody Cope cope) {
        return success(service.selObject(cope));
    }
}
