package com.muyu.edition.mapper;

import com.muyu.edition.domain.Config;

import java.util.List;

/**
 * 引擎Mapper接口
 *
 * @author muyu
 * @date 2024-05-04
 */
public interface ConfigMapper {
    /**
     * 查询引擎
     *
     * @param id 引擎主键
     * @return 引擎
     */
    public Config selectConfigById(Long id);

    /**
     * 查询引擎列表
     *
     * @param config 引擎
     * @return 引擎集合
     */
    public List<Config> selectConfigList(Config config);

    /**
     * 新增引擎
     *
     * @param config 引擎
     * @return 结果
     */
    public int insertConfig(Config config);

    /**
     * 修改引擎
     *
     * @param config 引擎
     * @return 结果
     */
    public int updateConfig(Config config);

    /**
     * 删除引擎
     *
     * @param id 引擎主键
     * @return 结果
     */
    public int deleteConfigById(Long id);

    /**
     * 批量删除引擎
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteConfigByIds(Long[] ids);

    List<Config> listConfigEs(Long ruleId);
}
