package com.muyu.edition.mapper;

import com.muyu.edition.domain.RuleEngine;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 规则引擎Mapper接口
 *
 * @author muyu
 * @date 2024-05-02
 */
public interface RuleEngineMapper {
    /**
     * 查询规则引擎
     *
     * @param ruleId 规则引擎主键
     * @return 规则引擎
     */
    public RuleEngine selectRuleEngineByRuleId(Long ruleId);

    /**
     * 查询规则引擎列表
     *
     * @param ruleEngine 规则引擎
     * @return 规则引擎集合
     */
    public List<RuleEngine> selectRuleEngineList(RuleEngine ruleEngine);

    /**
     * 新增规则引擎
     *
     * @param ruleEngine 规则引擎
     * @return 结果
     */
    public int insertRuleEngine(RuleEngine ruleEngine);

    /**
     * 修改规则引擎
     *
     * @param ruleEngine 规则引擎
     * @return 结果
     */
    public int updateRuleEngine(RuleEngine ruleEngine);

    /**
     * 删除规则引擎
     *
     * @param ruleId 规则引擎主键
     * @return 结果
     */
    public int deleteRuleEngineByRuleId(Long ruleId);

    /**
     * 批量删除规则引擎
     *
     * @param ruleIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRuleEngineByRuleIds(Long[] ruleIds);

    String description(@Param("ruleId") Integer ruleId);

    void updateRuleIsActivate(@Param("ruleId") Long ruleId, @Param("ruleIsActivate") String ruleIsActivate);

    void updateRuleStatus(@Param("ruleId") Long ruleId, @Param("ruleStatus") String ruleStatus);
}
