package com.muyu.edition.service;

import com.muyu.edition.domain.Edition;

import java.util.List;

/**
 * 规则引擎版本Service接口
 *
 * @author muyu
 * @date 2024-05-06
 */
public interface IEditionService {
    /**
     * 查询规则引擎版本
     *
     * @param id 规则引擎版本主键
     * @return 规则引擎版本
     */
    public Edition selectEditionById(Long id);

    /**
     * 获取相应的规则引擎版本
     *
     * @param ruleId
     * @return
     */
    List<Edition> selectListRuleId(Long ruleId);

    /**
     * 查询规则引擎版本列表
     *
     * @return 规则引擎版本集合
     */
    public List<Edition> selectEditionList();

    /**
     * 新增规则引擎版本
     *
     * @param edition 规则引擎版本
     * @return 结果
     */
    public int insertEdition(Edition edition);

    /**
     * 修改规则引擎版本
     *
     * @param edition 规则引擎版本
     * @return 结果
     */
    public int updateEdition(Edition edition);

    /**
     * 批量删除规则引擎版本
     *
     * @param ids 需要删除的规则引擎版本主键集合
     * @return 结果
     */
    public int deleteEditionByIds(Long[] ids);

    /**
     * 删除规则引擎版本信息
     *
     * @param id 规则引擎版本主键
     * @return 结果
     */
    public int deleteEditionById(Long id);

}
