package com.muyu.edition.service;

import com.muyu.common.core.domain.Result;
import com.muyu.edition.domain.RuleEngine;

import java.util.List;

/**
 * 规则引擎Service接口
 *
 * @author muyu
 * @date 2024-05-02
 */
public interface IRuleEngineService {
    /**
     * 查询规则引擎
     *
     * @param ruleId 规则引擎主键
     * @return 规则引擎
     */
    public RuleEngine selectRuleEngineByRuleId(Long ruleId);

    /**
     * 规则详情
     *
     * @param ruleId
     * @return
     */
    RuleEngine selectRuleEngineOne(Long ruleId);

    /**
     * 查询规则引擎列表
     *
     * @param ruleEngine 规则引擎
     * @return 规则引擎集合
     */
    public List<RuleEngine> selectRuleEngineList(RuleEngine ruleEngine);

    /**
     * 新增规则引擎
     *
     * @param ruleEngine 规则引擎
     * @return 结果
     */
    public int insertRuleEngine(RuleEngine ruleEngine);

    /**
     * 修改规则引擎
     *
     * @param ruleEngine 规则引擎
     * @return 结果
     */
    public int updateRuleEngine(RuleEngine ruleEngine);

    /**
     * 批量删除规则引擎
     *
     * @param ruleIds 需要删除的规则引擎主键集合
     * @return 结果
     */
    public int deleteRuleEngineByRuleIds(Long[] ruleIds);

    /**
     * 删除规则引擎信息
     *
     * @param ruleId 规则引擎主键
     * @return 结果
     */
    public int deleteRuleEngineByRuleId(Long ruleId);

    String description(Integer ruleId);

    void updateRuleIsActivate(RuleEngine ruleEngine);

    void updateRuleStatus(RuleEngine ruleEngine);

    Result spliceNameToCode(String name, String code, Integer level);
}
