import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class stream {
    public static void main(String[] args) throws IOException {
        // stream 获取list
        List<Integer> list = Arrays.asList(1, 2, 3);
        System.out.println(list);
        Stream<Integer> integerStream = list.stream();
        List<Integer> collect1 = integerStream.collect(Collectors.toList());
        System.out.println(collect1);
        // stream 获取数组
        Integer[] array = {1, 2, 3};
        Stream<Integer> arrStream = Arrays.stream(array);
        List<Integer> collect = arrStream.collect(Collectors.toList());
        System.out.println(collect);
        //中间处理
        List<String> stringList = new ArrayList<>();
        stringList.add("123456789@163.com");
        stringList.add("2596325@163.com");
        stringList.add("157492533@qq.com");
        stringList.add("1547859633@qq.com");
        stringList.add("1547859633@qq.com");
        //filter 筛选操作
        stringList.stream().filter(c -> c.contains("@163")).forEach(System.out::println);
        //map 映射 map(表::展示字段)
        System.out.println("筛选操作");
        stringList.stream().map(String::new).forEach(System.out::println);
        //flatMap 将每个元素映射为一个Stream对象,并将所有的Stream对象的元素合并为一个steam对象
        System.out.println("将所有的Stream对象的元素合并为一个steam对象");
        stringList.stream().flatMap(c -> Arrays.asList(c).stream()).forEach(System.out::println);
        // distinct 去除重复元素
        System.out.println("去除重复元素");
        stringList.stream().distinct().forEach(System.out::println);
        // sorted 对元素进行排序
        System.out.println("排序");
        stringList.stream().sorted((a, b) -> a.length() - b.length()).forEach(System.out::println);
        // peek 对每个元素进行特定操作
        System.out.println("对每个元素进行特定操作");
        stringList.stream().peek(c -> System.out.println(c.length())).map(p -> p.length() % 2 == 0).forEach(System.out::println);
        // limit 限制stream中的元素数量
        System.out.println("限制stream中的元素数量");
        stringList.stream().limit(1).forEach(System.out::println);
        //结束
        // forEach 对每个元素进行指定操作，无返回值
        //toArray 将流中的元素转为数组
        System.out.println("将流中的元素转为数组");
        String[] array1 = stringList.stream().toArray(String[]::new);
        for (String s : array1) {
            System.out.println(s);
        }
        //reduce 将流中的元素按照指定的操作进行归约，返回一个值
        // identity是初始值,accumulator是一个二次元操作符,通常用于与流中的元素进行聚合操作
        System.out.println("归约");
        Optional<Integer> reduce = list.stream().map(Integer::bitCount).reduce(Integer::compare);
        System.out.println(reduce.get());
        // collect 将流中的元素收集到一个集合中
        System.out.println("将流中的元素收集到一个集合中");
        Set<Integer> collect2 = list.stream().collect(Collectors.toSet());
        for (Integer i : collect2) {
            System.out.println(i);
        }
        //min 返回最小值 max返回最大值
        //count 返回流中的个数
        //allMatch 判断流中的所有元素是否满足给定的条件
        //noneMatch 判断流中所有的元素是否不满足给定条件
        //findFirst 返回流的第一个元素
        System.out.println("返回流的第一个元素");
        Optional<String> first = stringList.stream().findFirst();
        System.out.println(first.stream().collect(Collectors.toSet()));
        //findAny 返回流的任意一个元素


    }
}
