package com.muyu.system.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 资产详情对象 asset_model
 *
 * @author muyu
 * @date 2024-04-21
 */
public class AssetModel extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 名称
     */
    @Excel(name = "名称")
    private String name;

    /**
     * 注释
     */
    @Excel(name = "注释")
    private String annotation;

    /**
     * 是否主键Y/N
     */
    @Excel(name = "是否主键Y/N")
    private String key;

    /**
     * 类型
     */
    @Excel(name = "类型")
    private String type;

    /**
     * 映射类型
     */
    @Excel(name = "映射类型")
    private String mappingType;

    /**
     * 长度
     */
    @Excel(name = "长度")
    private Long length;

    /**
     * 小数位
     */
    @Excel(name = "小数位")
    private Long decimalPlace;

    /**
     * 是否为空
     */
    @Excel(name = "是否为空")
    private String nullNot;

    /**
     * 默认值
     */
    @Excel(name = "默认值")
    private String defaultValue;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAnnotation() {
        return annotation;
    }

    public void setAnnotation(String annotation) {
        this.annotation = annotation;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getMappingType() {
        return mappingType;
    }

    public void setMappingType(String mappingType) {
        this.mappingType = mappingType;
    }

    public Long getLength() {
        return length;
    }

    public void setLength(Long length) {
        this.length = length;
    }

    public Long getDecimalPlace() {
        return decimalPlace;
    }

    public void setDecimalPlace(Long decimalPlace) {
        this.decimalPlace = decimalPlace;
    }

    public String getNullNot() {
        return nullNot;
    }

    public void setNullNot(String nullNot) {
        this.nullNot = nullNot;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("name", getName())
                .append("annotation", getAnnotation())
                .append("key", getKey())
                .append("type", getType())
                .append("mappingType", getMappingType())
                .append("length", getLength())
                .append("decimalPlace", getDecimalPlace())
                .append("nullNot", getNullNot())
                .append("defaultValue", getDefaultValue())
                .toString();
    }
}
