package com.muyu.system.mapper;

import com.muyu.system.domain.AssetModel;
import com.muyu.system.domain.Library;
import com.muyu.system.domain.vo.TableVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 资产详情Mapper接口
 *
 * @author muyu
 * @date 2024-04-21
 */
public interface AssetModelMapper {
    /**
     * 查询资产详情
     *
     * @param annotation 资产详情主键
     * @return 资产详情
     */
    public AssetModel selectAssetModelByAnnotation(String annotation);

    /**
     * 查询资产详情列表
     *
     * @param assetModel 资产详情
     * @return 资产详情集合
     */
    public List<AssetModel> selectAssetModelList(AssetModel assetModel);

    /**
     * 新增资产详情
     *
     * @param assetModel 资产详情
     * @return 结果
     */
    public int insertAssetModel(AssetModel assetModel);

    /**
     * 修改资产详情
     *
     * @param assetModel 资产详情
     * @return 结果
     */
    public int updateAssetModel(AssetModel assetModel);

    /**
     * 删除资产详情
     *
     * @param annotation 资产详情主键
     * @return 结果
     */
    public int deleteAssetModelByAnnotation(String annotation);

    /**
     * 批量删除资产详情
     *
     * @param annotations 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAssetModelByAnnotations(String[] annotations);

    List<String> library();

    String database();

    List<TableVo> selectTable(@Param("database") String database, @Param("libraryName") String libraryName);

    List<Library> library2();
}
