package com.muyu.system.mapper;

import com.muyu.system.domain.DataAccess;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 数据接入Mapper接口
 *
 * @author muyu
 * @date 2024-04-21
 */
public interface DataAccessMapper {
    /**
     * 查询数据接入
     *
     * @param id 数据接入主键
     * @return 数据接入
     */
    public DataAccess selectDataAccessById(Long id);

    /**
     * 查询数据接入列表
     *
     * @param dataAccess 数据接入
     * @return 数据接入集合
     */
    public List<DataAccess> selectDataAccessList(DataAccess dataAccess);

    /**
     * 新增数据接入
     *
     * @param dataAccess 数据接入
     * @return 结果
     */
    public int insertDataAccess(DataAccess dataAccess);

    /**
     * 修改数据接入
     *
     * @param dataAccess 数据接入
     * @return 结果
     */
    public int updateDataAccess(DataAccess dataAccess);

    /**
     * 删除数据接入
     *
     * @param id 数据接入主键
     * @return 结果
     */
    public int deleteDataAccessById(Long id);

    /**
     * 批量删除数据接入
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteDataAccessByIds(Long[] ids);

    /**
     * 获取最后一位数据
     *
     * @return
     */
    DataAccess oneDataAccess();

    void insertMiddle(@Param("deptId") Long deptId, @Param("id") Long id, @Param("databaseName") String databaseName, @Param("tableName") String tableName);

    Integer oneSelFrimary(DataAccess dataAccess);

    void insertUserMiddle(@Param("userId") Long userId, @Param("id") Long id, @Param("databaseName") String databaseName, @Param("tableName") String tableName);

    Integer selectOneMiddel(@Param("deptId") Long deptId, @Param("id") Long id, @Param("databaseName") String databaseName, @Param("tableName") String tableName);

    Integer selectOneUserMiddel(@Param("userId") Long userId, @Param("id") Long id, @Param("databaseName") String databaseName, @Param("tableName") String tableName);

    void deleteFrimary(DataAccess dataAccess);

    void indexFrimary(@Param("dataAccess") DataAccess dataAccess, @Param("num") Integer num, @Param("i") Integer i);

    void inserttableList(@Param("dataAccess") DataAccess dataAccess, @Param("tableName") String tableName, @Param("annotation") String annotation, @Param("anInt") int anInt);

    void deleteTableList(DataAccess dataAccess);

    Integer selectAccessMapper(DataAccess dataAccess);
}
