package com.muyu.system.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.system.domain.DataAccess;
import com.muyu.system.domain.vo.FrimaryVo;
import com.muyu.system.remote.factory.DataMangSystemFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;

/**
 * 远程调用
 */
@FeignClient(
        contextId = "RemoteSys",
        value = ServiceNameConstants.SYSTEM_SERVICE,
        fallbackFactory = DataMangSystemFactory.class,
        path = "/access"
)
@Service
public interface RemoteSystemManageService {
    @GetMapping("/list")
    public Result<TableDataInfo<DataAccess>> list(DataAccess dataAccess);
}
