package com.muyu.system.remote.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.system.domain.DataAccess;
import com.muyu.system.domain.vo.FrimaryVo;
import com.muyu.system.remote.RemoteSystemManageService;
import org.springframework.cloud.openfeign.FallbackFactory;

import java.util.List;

/**
 * 熔断
 */
public class DataMangSystemFactory implements FallbackFactory<RemoteSystemManageService> {
    @Override
    public RemoteSystemManageService create(Throwable cause) {
        return new RemoteSystemManageService() {

            @Override
            public Result<TableDataInfo<DataAccess>> list(DataAccess dataAccess) {
                return Result.error(cause.getMessage());
            }
        };
    }
}
