package com.muyu.system.service;

import com.muyu.system.domain.AssetModel;
import com.muyu.system.domain.Library;
import com.muyu.system.domain.vo.TableVo;

import java.util.List;

/**
 * 资产详情Service接口
 *
 * @author muyu
 * @date 2024-04-21
 */
public interface IAssetModelService {
    /**
     * 查询资产详情
     *
     * @param annotation 资产详情主键
     * @return 资产详情
     */
    public AssetModel selectAssetModelByAnnotation(String annotation);

    /**
     * 查询资产详情列表
     *
     * @param assetModel 资产详情
     * @return 资产详情集合
     */
    public List<AssetModel> selectAssetModelList(AssetModel assetModel);

    /**
     * 新增资产详情
     *
     * @param assetModel 资产详情
     * @return 结果
     */
    public int insertAssetModel(AssetModel assetModel);

    /**
     * 修改资产详情
     *
     * @param assetModel 资产详情
     * @return 结果
     */
    public int updateAssetModel(AssetModel assetModel);

    /**
     * 批量删除资产详情
     *
     * @param annotations 需要删除的资产详情主键集合
     * @return 结果
     */
    public int deleteAssetModelByAnnotations(String[] annotations);

    /**
     * 删除资产详情信息
     *
     * @param annotation 资产详情主键
     * @return 结果
     */
    public int deleteAssetModelByAnnotation(String annotation);

    List<Library> library();

    List<TableVo> selectTable(String libraryName);
}
