package com.muyu.system.service;

import com.muyu.system.domain.DataAccess;

import java.sql.SQLException;
import java.util.List;

/**
 * 数据接入Service接口
 *
 * @author muyu
 * @date 2024-04-21
 */
public interface IDataAccessService {
    /**
     * 查询数据接入
     *
     * @param id 数据接入主键
     * @return 数据接入
     */
    public DataAccess selectDataAccessById(Long id);

    /**
     * 查询数据接入列表
     *
     * @param dataAccess 数据接入
     * @return 数据接入集合
     */
    public List<DataAccess> selectDataAccessList(DataAccess dataAccess);

    /**
     * 新增数据接入
     *
     * @param dataAccess 数据接入
     * @return 结果
     */
    public int insertDataAccess(DataAccess dataAccess) throws SQLException;

    /**
     * 修改数据接入
     *
     * @param dataAccess 数据接入
     * @return 结果
     */
    public int updateDataAccess(DataAccess dataAccess);

    /**
     * 批量删除数据接入
     *
     * @param ids 需要删除的数据接入主键集合
     * @return 结果
     */
    public int deleteDataAccessByIds(Long[] ids);

    /**
     * 删除数据接入信息
     *
     * @param id 数据接入主键
     * @return 结果
     */
    public int deleteDataAccessById(Long id);

    DataAccess oneDataAccess();

    Integer synchronization(DataAccess dataAccess) throws Exception;


}
