package com.muyu.system.service.impl;

import com.muyu.common.core.domain.Result;
import com.muyu.system.domain.*;
import com.muyu.system.domain.table.TableShow;
import com.muyu.system.domain.table.ToTalNum;
import com.muyu.system.domain.vo.FrimaryVo;
import com.muyu.system.domain.vo.TableVo;
import com.muyu.system.mapper.AccreditMapper;
import com.muyu.system.service.AccreditService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class AccreditServiceImpl implements AccreditService {
    @Autowired
    private AccreditMapper mapper;

    @Override
    public List<TableList> tableNameList(String databaseName) {
        List<TableList> list = mapper.tableNameList(databaseName);
        System.out.println(list);
        return list;
    }

    @Override
    public List<TableVo> selectTableXml(String tableName) {
        String database = mapper.database();
        List<TableVo> list = mapper.selectTableXml(database, tableName);
        System.out.println(list);
        return list;
    }

    @Override
    public List<String> tableNameList2() throws SQLException {
        List<String> list = mapper.tableNameList2();
        return list;
    }

    @Override
    @Transactional
    public Result listSqlJdbc(Connection connection, String tableName) throws SQLException {
        try {
            PreparedStatement pst = connection.prepareCall("select * from " + tableName);
            ResultSetMetaData rsd = pst.getMetaData();
            //获取元数据
            DatabaseMetaData metaData = connection.getMetaData();
            Map<String, String> columnComments = getColumnComments(metaData, tableName);
            for (int i = 0; i < rsd.getColumnCount(); i++) {
                System.out.println("java类型" + rsd.getColumnClassName(i + 1));
                System.out.println("数据库类型" + rsd.getColumnTypeName(i + 1));
                System.out.println("字段名称" + rsd.getColumnName(i + 1));
                System.out.println("表名" + rsd.getTableName(i + 1));
                System.out.println("数据库名" + rsd.getCatalogName(i + 1));
                System.out.println("模式名" + rsd.getSchemaName(i + 1));
                System.out.println("列数" + rsd.getColumnCount());
                System.out.println("列类型" + rsd.getColumnType(i + 1));
                System.out.println("列标签" + rsd.getColumnLabel(i + 1));
                System.out.println("列显示大小" + rsd.getColumnDisplaySize(i + 1));
                System.out.println("精度" + rsd.getPrecision(i + 1));
                System.out.println("规模" + rsd.getScale(i + 1));
                System.out.println("自增" + rsd.isAutoIncrement(i + 1));
                System.out.println("是否为空" + rsd.isNullable(i + 1));
                System.out.println("区分大小写" + rsd.isCaseSensitive(i + 1));
                System.out.println("是否是货币" + rsd.isCurrency(i + 1));
                System.out.println("可搜索" + rsd.isSearchable(i + 1));
                System.out.println("签署" + rsd.isSigned(i + 1));
                System.out.println("绝对可以写" + rsd.isDefinitelyWritable(i + 1));
                System.out.println("只读" + rsd.isReadOnly(i + 1));
                System.out.println("是可写的" + rsd.isWritable(i + 1));
                System.out.println("注解" + columnComments.get(rsd.getColumnName(i + 1)));
                System.out.println("val" + columnComments.keySet());
                ListStructure listStructure = new ListStructure();
                //获取数据库名
                listStructure.setCatalogName(rsd.getCatalogName(i + 1));
                //获取表名
                listStructure.setTableName(rsd.getTableName(i + 1));
                //获取java类型
                listStructure.setColumnLassName(rsd.getColumnClassName(i + 1));
                //获取映射类型
                listStructure.setColumnTypeName(rsd.getColumnTypeName(i + 1));
                //获取字段名称
                listStructure.setColumnName(rsd.getColumnName(i + 1));
                //获取长度
                listStructure.setPrecisions(rsd.getPrecision(i + 1));
                //获取小数
                listStructure.setScale(rsd.getScale(i + 1));
                //获取非空
                listStructure.setIsNull(rsd.isNullable(i + 1));
                //获取默认
                listStructure.setSchemaName(rsd.getSchemaName(i + 1));
                //获取注解
                listStructure.setColumnComments(columnComments.get(rsd.getColumnName(i + 1)));
                mapper.insertListStructure(listStructure);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return Result.success("OK");
    }

    @Override
    public List<ListStructure> listListstructure() {
        return mapper.listListstructure();
    }

    @Override
    public TableList selNameTableList(String databaseName, String name) {
        return mapper.selNameTableList(databaseName, name);
    }

    @Override
    public List<ListStructure> selNameListStructure(String tableName, String databaseName) {
        return mapper.selNameListStructure(tableName, databaseName);
    }


    @Override
    public Integer updateListStructure(ListStructure listStructure) {
        //判断是否加入字典
        if (!listStructure.getYesOrNo().equals("Y")) {
            listStructure.setDictionary(null);
        }
        //修改状态
        Integer i = mapper.updateListStructure(listStructure);
        return i;
    }

    @Override
    public Integer selJDBCStream(DataAccess dataAccess) {
        Integer id = 0;

        try {
            //加载数据库驱动
            Class<?> aClass = Class.forName("com.mysql.cj.jdbc.Driver");
            Driver driver = (Driver) aClass.newInstance();
            //获取数据库连接
            Connection connection = DriverManager.getConnection("jdbc:mysql://" + dataAccess.getHost() + ":" + dataAccess.getPort() + "/" + dataAccess.getDatabaseName() + "?serverTimezone=UTC", dataAccess.getUsername(), dataAccess.getPassword());
            System.out.println(driver);
            System.out.println(connection);
            id = 1;
        } catch (Exception e) {
            id = 0;
        }
        return id;
    }

    @Override
    public Integer selJDBCStream2(DataAccess dataAccess) {
        Integer id = 0;
        List<String> stringList = new ArrayList<>();
        // 连接数据
//        try {
//            Class<?> aClass = Class.forName("com.mysql.cj.jdbc.Driver");
//            Driver driver = (Driver) aClass.newInstance();
////            //获取数据库连接
//            Connection connection = DriverManager.getConnection("jdbc:mysql://" + dataAccess.getHost() + ":" + dataAccess.getPort() + "/" + dataAccess.getDatabaseName() + "?useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8", dataAccess.getUsername(), dataAccess.getPassword());
////            //获取数据库名
////            //获取数据库的元数据
//            DatabaseMetaData metaData = connection.getMetaData();
//            //获取全部表名
//            Statement statement = connection.createStatement();
//            ResultSet rst = statement.executeQuery("select TABLE_NAME from INFORMATION_SCHEMA.Tables where table_schema = '" + dataAccess.getDatabaseName() + "'");
//            mapper.deleteTableShow(dataAccess.getName());
//            while (rst.next()) {
//                stringList.add(rst.getString(1));
//            }
//            for (String s : stringList) {
//                // 执行查询
//                ResultSet rs = statement.executeQuery("select * from " + s);
//                PreparedStatement pst = connection.prepareCall("select * from " + s);
//                ResultSetMetaData rsd = pst.getMetaData();
//                // 获取查询的结果集
//                ResultSetMetaData md = rs.getMetaData();
//                System.out.println(md);
//                int columnCount = md.getColumnCount();
//                System.out.println(columnCount);
//                //获取结果集的元数据
//                //遍历结果集
//                while (rs.next()) {
//                    for (int i = 1; i <= columnCount; i++) {
//                            //获取列名
//                            String fields = md.getColumnName(i);
//                            System.out.println(fields);
//                            //获取表名
//                            String tableName = md.getTableName(i);
//                            System.out.println(tableName);
//                            //获取字段值
//                            Object val = rs.getObject(i);
//                            System.out.println(val);
//                            //获取java映射字段类型
//                            String columnClassName = md.getColumnClassName(i);
//                            mapper.indexTableShow(dataAccess.getName() + "." + tableName + "." + fields, columnClassName, val.toString());
//                        }
//                    }
//            }
//            id =1;
//        } catch (Exception e) {
//            id = 0;
//        }
        return id;
    }


    @Override
    public List<FrimaryVo> selectFrimary() {
        List<FrimaryVo> list = mapper.selectFrimary();
        for (FrimaryVo frimaryVo : list) {
            List<TableList> tableLists = mapper.tableNameList(frimaryVo.getDatabaseName());
            frimaryVo.setTableLists(tableLists);
        }
        return list;
    }

    @Override
    public List<Middle> listMiddle(String tableName, String databaseName) {
        return mapper.listMiddle(tableName, databaseName);
    }

    @Override
    public List<Middle> listMiddle2(String databaseName) {
        return mapper.listMiddle2(databaseName);
    }

    @Override
    public List<UserMiddle> listUserMiddle(String tableName, String databaseName) {
        return mapper.listUserMiddle(tableName, databaseName);
    }

    @Override
    public List<UserMiddle> listUserMiddle2(String databaseName) {
        return mapper.listUserMiddle2(databaseName);
    }

    @Override
    public Integer updateMiddle(Integer mid, String statusId) {
        return mapper.updateMiddle(mid, statusId);
    }

    @Override
    public Integer updateUserMiddle(Integer mid, String statusId) {
        return mapper.updateUserMiddle(mid, statusId);
    }

    @Override
    public List<TableShow> selectShow(String tableName) {
        List<TableShow> showList = mapper.selectShow(tableName);
        return showList;
    }

    @Override
    public ToTalNum selTotalNum() {
        Integer fieldsNum = 0;
        ToTalNum toTalNum = new ToTalNum();
        Integer switchOns = mapper.selectOneFrimary();
        Integer assetsNum = mapper.selectOneTableListNum();
        List<TableList> tableListList = mapper.selectTableList();
        for (TableList tableList : tableListList) {
            fieldsNum += tableList.getDataTotal();
        }
        toTalNum.setSwitchOns(switchOns);
        toTalNum.setAssetsNum(assetsNum);
        toTalNum.setFieldsNum(fieldsNum);
        return toTalNum;
    }

    //获取字段注解
    private Map<String, String> getColumnComments(DatabaseMetaData metaData, String typeName) {
        Map<String, String> columnComents = new HashMap<>();
        try (ResultSet colums = metaData.getColumns(null, null, typeName, null)) {
            while (colums.next()) {
                String columsName = colums.getString("COLUMN_NAME");
                String columsComment = colums.getString("REMARKS");
                columnComents.put(columsName, columsComment);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return columnComents;
    }

    //获取字段默认值
    private Map<String, String> getDefault(DatabaseMetaData metaData, String defaultName) {
        Map<String, String> defaults = new HashMap<>();
        try (ResultSet colums = metaData.getColumns(null, null, defaultName, null)) {
            while (colums.next()) {
                String columsName = colums.getString("COLUMN_NAME");
                String defaultComment = colums.getString("COLUMN_DEFAULT");
                defaults.put(columsName, defaultComment);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return defaults;
    }

}
