package com.muyu.system.service.impl;

import com.muyu.system.domain.DictData;
import com.muyu.system.domain.DictType;
import com.muyu.system.mapper.DictMapper;
import com.muyu.system.service.DictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DictServiceImpl implements DictService {
    @Autowired
    private DictMapper mapper;

    @Override
    public List<DictType> listDictType() {
        List<DictType> list = mapper.listDictType();
        for (DictType dictType : list) {
            List<DictData> list1 = selDictData(dictType.getDictType());
            dictType.setDictDataList(list1);
        }
        return list;
    }

    @Override
    public List<DictData> selDictData(String dictType) {
        return mapper.selDictData(dictType);
    }

    /**
     * 添加字典
     *
     * @param dictType
     * @return
     */
    @Override
    public Integer indexDictType(String dictType) {
        Integer id = mapper.indexDictType(dictType);
        return id;
    }

    @Override
    public Integer indexDictData(DictData dictData) {
        if (dictData.getDictCode() == 0) {
            return mapper.indexDictData(dictData);
        } else {
            return mapper.updDictData(dictData);
        }

    }

    @Override
    public Integer deleteDictData(DictData dictData) {
        return mapper.deleteDictData(dictData);
    }

    @Override
    public DictData selectDictData(DictData dictData) {
        return mapper.selectDictData(dictData);
    }

    @Override
    public Integer deleteDictType(String dictType) {
        return mapper.deleteDictType(dictType);
    }

    @Override
    public Integer deleteDictDatas(String dictType) {
        return mapper.deleteDictDatas(dictType);
    }

    @Override
    public DictType selectDictType(String dictType) {
        return mapper.selectDictType(dictType);
    }

}
